unit principale;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.Controls3D,
  System.Math.Vectors, FMX.Types3D, FMX.Ani, FMX.Objects3D, FMX.MaterialSources, FMX.Viewport3D, system.math,
  FMX.Controls.Presentation, FMX.StdCtrls, FMX.Layouts, FMX.Objects;

type
  TfPrincipale = class(TForm)
    viewport: TViewport3D;
    dmyScene: TDummy;
    sol: TPlane;
    textureSol: TLightMaterialSource;
    lumiere: TLight;
    buche1: TCylinder;
    texturebois: TLightMaterialSource;
    buche2: TCylinder;
    buche3: TCylinder;
    FloatAnimation1: TFloatAnimation;
    fond: TSphere;
    texturefond: TTextureMaterialSource;
    textureFlamme: TLightMaterialSource;
    dmyFeu: TDummy;
    textureFumee: TLightMaterialSource;
    layVent: TLayout;
    TrackBar1: TTrackBar;
    RoundRect1: TRoundRect;
    StyleBook1: TStyleBook;
    procedure dmyFeuRender(Sender: TObject; Context: TContext3D);
  private
    procedure GenererFlammes(Sender: TObject; nbPlane: integer);
  public
  end;

var
  fPrincipale: TfPrincipale;

implementation
{$R *.fmx}

procedure TfPrincipale.dmyFeuRender(Sender: TObject; Context: TContext3D);
begin
  GenererFlammes(sender, 100);   // Gnre les TPlanes simulant les flammes (par dfaut, on va simuler les flammes avec 100 TPlanes)
end;

procedure TfPrincipale.GenererFlammes(Sender: TObject; nbPlane : integer);
var
  s:TPlane;      // Pour cration des TPlane
  P:TFmxObject;  // Va servir d'itrateur pour parcourir tous les objets enfants du dmyFeu
  step : single; // intervalle entre chaque transformation de TPlane
begin
  step := 1/nbPlane; // Pour viter d'avoir  faire ce calcul  chaque fois que step est utilis plus tard dans cette mthode

  if TDummy(sender).ChildrenCount-1 < nbPlane then // Cration des TPlane pour les flammes. On va en crer jusqu' la limite passe en paramtre.
  begin
    s:=TPlane.Create(nil);
    s.parent := buche1.Parent;                // La parent du TPlane sera la buche1
    s.SetSize(1,1,0);                         // On positionne la taille du TPlane
    s.MaterialSource:=textureFlamme;          // On lui affecte la texture
    s.Position.Point:=buche1.Position.Point;  // On le positionne  la position de la buche1
    TAnimator.AnimateFloat(s,'RotationAngle.Z',359,random); // On lui affecte une animation de rotation sur l'axe Z =>  les rotations sont l pour donner un peu de volume aux TPlane et donc aux flammes
    TAnimator.AnimateFloat(s,'RotationAngle.X',359,random); // On lui affecte une animation de rotation sur l'axe X =>
  end;

  for P in TDummy(Sender).Children do // Parcours des objets enfants du dmyFeu
  begin
    if P is TPlane then // Si l'objet est un TPlane
    begin
      s := TPlane(P);   // On va travailler sur ce TPlane
      s.position.y := s.position.y - step * random * 8; // On le dcalle vers le haut avec un peu d'alatoire pour mieux simuler les flammes (changez le 8 pour faire monter plus ou moins haut les flammes)
      if s.position.y < -2.5 then s.position.x := s.position.x + (TrackBar1.Value-5)/300 * random(10);   // si le TPlane monte suffisemment haut, on le dcalle sur l'axe des X en fonction du trackbar pour un effet de vent :)
      s.height := s.Height - step;  // On rduit la hauteur du TPlane
      s.width := s.width - step;    // On rduit la largeur du TPlane
      if s.height < 0  then      // Si la hauteur du TPlane < 0, alors on repositionne le TPlane  sa taille et position d'origine
      begin
        s.SetSize(1,1,0);
        s.Position.point := buche1.Position.Point;
      end;
    end;
  end;
end;

end.
